## @file
# Define Global Variables

package GVariables;

##################################################
## the object constructor (simplistic version)  ##
##################################################
sub new {
    my $self  = {};    
    $self->{SRC_Name}             = "[SourceName]";
    $self->{SRC_OBSID}            = "[ObsID]";
    $self->{SRC_EXP}              = "[Exposure]";
    $self->{SRC_RA}               = undef;
    $self->{SRC_DEC}              = undef; 
    $self->{PN}					  = undef;
    $self->{MOS}				  = undef;
    $self->{RGS}				  = undef;
    $self->{OM}					  = undef;
    $self->{pn_interactive}		  = undef;
    $self->{mos1_interactive}     = undef;
    $self->{mos2_interactive}		  = undef;
    $self->{ANA_epatplot}	      = undef;
    $self->{GTI_optimize_SN_flag} = undef;
    $self->{GTI_mos1energy_cut}   = undef;
    $self->{GTI_mos2energy_cut}   = undef;
    $self->{GTI_pnenergy_cut}     = undef;
    $self->{GTI_MOS1_Rate}        = undef;
    $self->{GTI_MOS2_Rate}        = undef;
    $self->{GTI_PN_Rate}          = undef;
    $self->{GTI_timebin}          = undef;
    $self->{EDC_pn_ene_low}       = [];
    $self->{EDC_pn_ene_high}      = [];
    $self->{EDC_m1_ene_low}       = [];
    $self->{EDC_m1_ene_high}      = [];
    $self->{EDC_m2_ene_low}       = [];
    $self->{EDC_m2_ene_high}      = [];
    $self->{EDC_pn_likelihood_detection}  = undef;
    $self->{EDC_mos_likelihood_detection} = undef;
    $self->{EDC_sourcematch} = undef;
    $self->{EDC_cameramatch} = undef;
    $self->{OM_sourcematch}  = undef;
    $self->{PG_timebinning}  = undef;
    $self->{PG_timestart}    = undef;
    $self->{PG_timeend}      = undef;
    $self->{PG_minpi}        = undef;
    $self->{PG_maxpi}        = undef;
    $self->{PG_aringcx}      = undef;
    $self->{PG_aringcy}      = undef;
    $self->{PG_innerrad}     = undef;
    $self->{PG_outerrad}     = undef;
    $self->{PG_sx}           = undef;
    $self->{PG_sy}           = undef;
    $self->{PG_source_rad}   = undef;
    $self->{PG_areafactor}   = undef;
    $self->{PG_src_region}   = undef;
    $self->{PG_bkg_region}   = undef;
    $self->{LC_pn_e1_low}      = undef;
    $self->{LC_pn_e1_up}       = undef;
    $self->{LC_m1_e1_low}      = undef;
    $self->{LC_m1_e1_up}       = undef;
    $self->{LC_m2_e1_low}      = undef;
    $self->{LC_m2_e1_up}       = undef; 
    $self->{LC_pn_srcregion}         = undef;
    $self->{LC_pn_bkgregion}         = undef;
    $self->{LC_pn_srcregion_X}       = undef;
    $self->{LC_pn_srcregion_Y}       = undef;
    $self->{LC_pn_srcregion_R1}      = undef;
    $self->{LC_pn_srcregion_R2}      = undef;
    $self->{LC_pn_srcregion_XLength} = undef;
    $self->{LC_pn_srcregion_YLength} = undef;
    $self->{LC_pn_bkgregion_X}       = undef;
    $self->{LC_pn_bkgregion_Y}       = undef;
    $self->{LC_pn_bkgregion_R1}      = undef;
    $self->{LC_pn_bkgregion_R2}      = undef;
    $self->{LC_pn_bkgregion_XLength} = undef;
    $self->{LC_pn_bkgregion_YLength} = undef;
    $self->{LC_pn_areafactor}        = undef;
    $self->{LC_m1_srcregion}         = undef;
    $self->{LC_m1_bkgregion}         = undef;
    $self->{LC_m1_srcregion_X}       = undef;
    $self->{LC_m1_srcregion_Y}       = undef;
    $self->{LC_m1_srcregion_R1}      = undef;
    $self->{LC_m1_srcregion_R2}      = undef;
    $self->{LC_m1_srcregion_XLength} = undef;
    $self->{LC_m1_srcregion_YLength} = undef;
    $self->{LC_m1_bkgregion_X}       = undef;
    $self->{LC_m1_bkgregion_Y}       = undef;
    $self->{LC_m1_bkgregion_R1}      = undef;
    $self->{LC_m1_bkgregion_R2}      = undef;
    $self->{LC_m1_bkgregion_XLength} = undef;
    $self->{LC_m1_bkgregion_YLength} = undef;
    $self->{LC_m1_areafactor}        = undef;
    $self->{LC_m2_srcregion}         = undef;
    $self->{LC_m2_bkgregion}         = undef;
    $self->{LC_m2_srcregion_X}       = undef;
    $self->{LC_m2_srcregion_Y}       = undef;
    $self->{LC_m2_srcregion_R1}      = undef;
    $self->{LC_m2_srcregion_R2}      = undef;
    $self->{LC_m2_srcregion_XLength} = undef;
    $self->{LC_m2_srcregion_YLength} = undef;
    $self->{LC_m2_bkgregion_X}       = undef;
    $self->{LC_m2_bkgregion_Y}       = undef;
    $self->{LC_m2_bkgregion_R1}      = undef;
    $self->{LC_m2_bkgregion_R2}      = undef;
    $self->{LC_m2_bkgregion_XLength} = undef;
    $self->{LC_m2_bkgregion_YLength} = undef;
    $self->{LC_m2_areafactor}        = undef;
    
    $self->{LC_pn_src_expr}    	  = undef;
    $self->{LC_pn_bkg_expr}          = undef;
    $self->{LC_m1_src_expr}          = undef;
    $self->{LC_m1_bkg_expr}          = undef;
    $self->{LC_m2_src_expr}          = undef;
    $self->{LC_m2_bkg_expr}          = undef;

    $self->{LC_pn_timebinsize}   = undef;   
    $self->{LC_m1_timebinsize}   = undef;   
    $self->{LC_m2_timebinsize}   = undef;
   
    $self->{SPC_pn_srcregion}         = undef;
    $self->{SPC_pn_bkgregion}         = undef;
    $self->{SPC_pn_srcregion_X}       = undef;
    $self->{SPC_pn_srcregion_Y}       = undef;
    $self->{SPC_pn_srcregion_R1}      = undef;
    $self->{SPC_pn_srcregion_R2}      = undef;
    $self->{SPC_pn_srcregion_XLength} = undef;
    $self->{SPC_pn_srcregion_YLength} = undef;
    $self->{SPC_pn_bkgregion_X}       = undef;
    $self->{SPC_pn_bkgregion_Y}       = undef;
    $self->{SPC_pn_bkgregion_R1}      = undef;
    $self->{SPC_pn_bkgregion_R2}      = undef;
    $self->{SPC_pn_bkgregion_XLength} = undef;
    $self->{SPC_pn_bkgregion_YLength} = undef;
    $self->{SPC_pn_areafactor}        = undef;
    $self->{SPC_m1_srcregion}         = undef;
    $self->{SPC_m1_bkgregion}         = undef;
    $self->{SPC_m1_srcregion_X}       = undef;
    $self->{SPC_m1_srcregion_Y}       = undef;
    $self->{SPC_m1_srcregion_R1}      = undef;
    $self->{SPC_m1_srcregion_R2}      = undef;
    $self->{SPC_m1_srcregion_XLength} = undef;
    $self->{SPC_m1_srcregion_YLength} = undef;
    $self->{SPC_m1_bkgregion_X}       = undef;
    $self->{SPC_m1_bkgregion_Y}       = undef;
    $self->{SPC_m1_bkgregion_R1}      = undef;
    $self->{SPC_m1_bkgregion_R2}      = undef;
    $self->{SPC_m1_bkgregion_XLength} = undef;
    $self->{SPC_m1_bkgregion_YLength} = undef;
    $self->{SPC_m1_areafactor}        = undef;
    $self->{SPC_m2_srcregion}         = undef;
    $self->{SPC_m2_bkgregion}         = undef;
    $self->{SPC_m2_srcregion_X}       = undef;
    $self->{SPC_m2_srcregion_Y}       = undef;
    $self->{SPC_m2_srcregion_R1}      = undef;
    $self->{SPC_m2_srcregion_R2}      = undef;
    $self->{SPC_m2_srcregion_XLength} = undef;
    $self->{SPC_m2_srcregion_YLength} = undef;
    $self->{SPC_m2_bkgregion_X}       = undef;
    $self->{SPC_m2_bkgregion_Y}       = undef;
    $self->{SPC_m2_bkgregion_R1}      = undef;
    $self->{SPC_m2_bkgregion_R2}      = undef;
    $self->{SPC_m2_bkgregion_XLength} = undef;
    $self->{SPC_m2_bkgregion_YLength} = undef;
    $self->{SPC_m2_areafactor}        = undef;
    
    $self->{SPC_pn_src_expr}    	  = undef;
    $self->{SPC_pn_bkg_expr}          = undef;
    $self->{SPC_m1_src_expr}          = undef;
    $self->{SPC_m1_bkg_expr}          = undef;
    $self->{SPC_m2_src_expr}          = undef;
    $self->{SPC_m2_bkg_expr}          = undef;
    
    
    $self->{LC_rgs1_orders}         = "1 2";
    $self->{LC_rgs1_timebinsize}         = 200;
    $self->{LC_rgs2_orders}         = "1 2";
    $self->{LC_rgs2_timebinsize}         = 200;
    
#... RGS parameters
    
	$self->{RGS_withsrc}   = undef;
	$self->{RGS_srcstyle} = undef;
	$self->{RGS_srcra} = undef;
	$self->{RGS_srcdec} = undef;
	$self->{RGS_srcdisp} = undef;
	$self->{RGS_srcxdsp} = undef;
	$self->{RGS_srclabel} = undef;
	$self->{RGS_srcrate} = undef;
	$self->{RGS_keepcool} = undef;
	$self->{RGS_rejflags} = undef;
	$self->{RGS_spectrumbinnig} = undef; 
    	   
    bless($self);          
    return $self;
}


sub print {
    my $self = shift;
    print "---> psechain variables <----\n";
    print "SRC_Name = $self->{SRC_Name}\n";    
	print "SRC_OBSID = $self->{SRC_OBSID}\n";
	print "SRC_EXP = $self->{SRC_EXP}\n"; 
	print "SRC_RA = $self->{SRC_RA}\n";
	print "SRC_DEC = $self->{SRC_DEC}\n";
	print "PN = $self->{PN}\n";
	print "MOS = $self->{MOS}\n";
	print "RGS = $self->{RGS}\n";
	print "OM = $self->{OM}\n";
	print "pn_interactive = $self->{pn_interactive}\n";
	print "mos1_interactive = $self->{mos1_interactive}\n";
	print "mos2_interactive = $self->{mos2_interactive}\n";
	print "ANA_epatplot = $self->{ANA_epatplot}\n";
	print "GTI_optimize_SN_flag = $self->{GTI_optimize_SN_flag}\n";
	print "GTI_mos1energy_cut = $self->{GTI_mos1energy_cut}\n";
	print "GTI_mos2energy_cut = $self->{GTI_mos2energy_cut}\n";
	print "GTI_pnenergy_cut = $self->{GTI_pnenergy_cut}\n";
	print "GTI_MOS1_Rate = $self->{GTI_MOS1_Rate}\n";
	print "GTI_MOS2_Rate = $self->{GTI_MOS2_Rate}\n";
	print "GTI_PN_Rate = $self->{GTI_PN_Rate}\n";
	print "GTI_timebin = $self->{GTI_timebin}\n";
	@tmp = $self->EDC_pn_ene_low;
	print "EDC_pn_ene_low = @tmp\n";
	@tmp = $self->EDC_pn_ene_high;
	print "EDC_pn_ene_high = @tmp\n";
	@tmp = $self->EDC_m1_ene_low;
	print "EDC_m1_ene_low = @tmp\n";
	@tmp = $self->EDC_m1_ene_high;
	print "EDC_m1_ene_high = @tmp\n";
	@tmp = $self->EDC_m2_ene_low;
	print "EDC_m2_ene_low = @tmp\n";
	@tmp = $self->EDC_m2_ene_high;
	print "EDC_m2_ene_high = @tmp\n";
	print "EDC_pn_likelihood_detection = $self->{EDC_pn_likelihood_detection}\n";
	print "EDC_mos_likelihood_detection = $self->{EDC_mos_likelihood_detection}\n";
	print "EDC_sourcematch = $self->{EDC_sourcematch}\n";
	print "EDC_cameramatch = $self->{EDC_cameramatch}\n";
	print "OM_sourcematch = $self->{OM_sourcematch}\n";
	print "PG_timebinning = $self->{PG_timebinning}\n";
	print "PG_timestart = $self->{PG_timestart}\n";
	print "PG_timeend = $self->{PG_timeend}\n";
	print "PG_minpi = $self->{PG_minpi}\n";
	print "PG_maxpi = $self->{PG_maxpi}\n";
	print "PG_aringcx = $self->{PG_aringcx}\n";
	print "PG_aringcy = $self->{PG_aringcy}\n";
	print "PG_innerrad = $self->{PG_innerrad}\n";
	print "PG_outerrad = $self->{PG_outerrad}\n";
	print "PG_sx = $self->{PG_sx}\n";
	print "PG_sy = $self->{PG_sy}\n";
	print "PG_source_rad = $self->{PG_source_rad}\n";
	print "PG_areafactor = $self->{PG_areafactor}\n";
	print "PG_src_region = $self->{PG_src_region}\n";
	print "PG_bkg_region = $self->{PG_bkg_region}\n";	
	print "LC_pn_e1_low = $self->{LC_pn_e1_low}\n";
	print "LC_pn_e1_up = $self->{LC_pn_e1_up}\n";
	print "LC_m1_e1_low = $self->{LC_m1_e1_low}\n";
	print "LC_m1_e1_up = $self->{LC_m1_e1_up}\n";
	print "LC_m2_e1_low = $self->{LC_m2_e1_low}\n";
	print "LC_m2_e1_up = $self->{LC_m2_e1_up}\n";
	print "LC_pn_srcregion = $self->{LC_pn_srcregion}\n";
	print "LC_pn_bkgregion = $self->{LC_pn_bkgregion}\n";
	print "LC_pn_srcregion_X = $self->{LC_pn_srcregion_X}\n";
	print "LC_pn_srcregion_Y = $self->{LC_pn_srcregion_Y}\n";
	print "LC_pn_srcregion_R1 = $self->{LC_pn_srcregion_R1}\n";
	print "LC_pn_srcregion_R2 = $self->{LC_pn_srcregion_R2}\n";
	print "LC_pn_srcregion_XLength = $self->{LC_pn_srcregion_XLength}\n";
	print "LC_pn_srcregion_YLength = $self->{LC_pn_srcregion_YLength}\n";
	print "LC_pn_bkgregion_X = $self->{LC_pn_bkgregion_X}\n";
	print "LC_pn_bkgregion_Y = $self->{LC_pn_bkgregion_Y}\n";
	print "LC_pn_bkgregion_R1 = $self->{LC_pn_bkgregion_R1}\n";
	print "LC_pn_bkgregion_R2 = $self->{LC_pn_bkgregion_R2}\n";
	print "LC_pn_bkgregion_XLength = $self->{LC_pn_bkgregion_XLength}\n";
	print "LC_pn_bkgregion_YLength = $self->{LC_pn_bkgregion_YLength}\n";
	print "LC_pn_areafactor = $self->{LC_pn_areafactor}\n";
	print "LC_m1_srcregion = $self->{LC_m1_srcregion}\n";
	print "LC_m1_bkgregion = $self->{LC_m1_bkgregion}\n";
	print "LC_m1_srcregion_X = $self->{LC_m1_srcregion_X}\n";
	print "LC_m1_srcregion_Y = $self->{LC_m1_srcregion_Y}\n";
	print "LC_m1_srcregion_R1 = $self->{LC_m1_srcregion_R1}\n";
	print "LC_m1_srcregion_R2 = $self->{LC_m1_srcregion_R2}\n";
	print "LC_m1_srcregion_XLength = $self->{LC_m1_srcregion_XLength}\n";
	print "LC_m1_srcregion_YLength = $self->{LC_m1_srcregion_YLength}\n";
	print "LC_m1_bkgregion_X = $self->{LC_m1_bkgregion_X}\n";
	print "LC_m1_bkgregion_Y = $self->{LC_m1_bkgregion_Y}\n";
	print "LC_m1_bkgregion_R1 = $self->{LC_m1_bkgregion_R1}\n";
	print "LC_m1_bkgregion_R2 = $self->{LC_m1_bkgregion_R2}\n";
	print "LC_m1_bkgregion_XLength = $self->{LC_m1_bkgregion_XLength}\n";
	print "LC_m1_bkgregion_YLength = $self->{LC_m1_bkgregion_YLength}\n";
	print "LC_m1_areafactor = $self->{LC_m1_areafactor}\n";
	print "LC_m2_srcregion = $self->{LC_m2_srcregion}\n";
	print "LC_m2_bkgregion = $self->{LC_m2_bkgregion}\n";
	print "LC_m2_srcregion_X = $self->{LC_m2_srcregion_X}\n";
	print "LC_m2_srcregion_Y = $self->{LC_m2_srcregion_Y}\n";
	print "LC_m2_srcregion_R1 = $self->{LC_m2_srcregion_R1}\n";
	print "LC_m2_srcregion_R2 = $self->{LC_m2_srcregion_R2}\n";
	print "LC_m2_srcregion_XLength = $self->{LC_m2_srcregion_XLength}\n";
	print "LC_m2_srcregion_YLength = $self->{LC_m2_srcregion_YLength}\n";
	print "LC_m2_bkgregion_X = $self->{LC_m2_bkgregion_X}\n";
	print "LC_m2_bkgregion_Y = $self->{LC_m2_bkgregion_Y}\n";
	print "LC_m2_bkgregion_R1 = $self->{LC_m2_bkgregion_R1}\n";
	print "LC_m2_bkgregion_R2 = $self->{LC_m2_bkgregion_R2}\n";
	print "LC_m2_bkgregion_XLength = $self->{LC_m2_bkgregion_XLength}\n";
	print "LC_m2_bkgregion_YLength = $self->{LC_m2_bkgregion_YLength}\n";
	print "LC_m2_areafactor = $self->{LC_m2_areafactor}\n";
	print "LC_pn_src_expr = $self->{LC_pn_src_expr}\n";
	print "LC_pn_bkg_expr = $self->{LC_pn_bkg_expr}\n";
	print "LC_m1_src_expr = $self->{LC_m1_src_expr}\n";
	print "LC_m1_bkg_expr = $self->{LC_m1_bkg_expr}\n";
	print "LC_m2_src_expr = $self->{LC_m2_src_expr}\n";
	print "LC_m2_bkg_expr = $self->{LC_m2_bkg_expr}\n";
	print "LC_pn_timebinsize = $self->{LC_pn_timebinsize}\n";
	print "LC_m1_timebinsize = $self->{LC_m1_timebinsize}\n";
	print "LC_m2_timebinsize = $self->{LC_m2_timebinsize}\n";
	print "SPC_pn_srcregion = $self->{SPC_pn_srcregion}\n";
	print "SPC_pn_bkgregion = $self->{SPC_pn_bkgregion}\n";
	print "SPC_pn_srcregion_X = $self->{SPC_pn_srcregion_X}\n";
	print "SPC_pn_srcregion_Y = $self->{SPC_pn_srcregion_Y}\n";
	print "SPC_pn_srcregion_R1 = $self->{SPC_pn_srcregion_R1}\n";
	print "SPC_pn_srcregion_R2 = $self->{SPC_pn_srcregion_R2}\n";
	print "SPC_pn_srcregion_XLength = $self->{SPC_pn_srcregion_XLength}\n";
	print "SPC_pn_srcregion_YLength = $self->{SPC_pn_srcregion_YLength}\n";
	print "SPC_pn_bkgregion_X = $self->{SPC_pn_bkgregion_X}\n";
	print "SPC_pn_bkgregion_Y = $self->{SPC_pn_bkgregion_Y}\n";
	print "SPC_pn_bkgregion_R1 = $self->{SPC_pn_bkgregion_R1}\n";
	print "SPC_pn_bkgregion_R2 = $self->{SPC_pn_bkgregion_R2}\n";
	print "SPC_pn_bkgregion_XLength = $self->{SPC_pn_bkgregion_XLength}\n";
	print "SPC_pn_bkgregion_YLength = $self->{SPC_pn_bkgregion_YLength}\n";
	print "SPC_pn_areafactor = $self->{SPC_pn_areafactor}\n";
	print "SPC_m1_srcregion = $self->{SPC_m1_srcregion}\n";
	print "SPC_m1_bkgregion = $self->{SPC_m1_bkgregion}\n";
	print "SPC_m1_srcregion_X = $self->{SPC_m1_srcregion_X}\n";
	print "SPC_m1_srcregion_Y = $self->{SPC_m1_srcregion_Y}\n";
	print "SPC_m1_srcregion_R1 = $self->{SPC_m1_srcregion_R1}\n";
	print "SPC_m1_srcregion_R2 = $self->{SPC_m1_srcregion_R2}\n";
	print "SPC_m1_srcregion_XLength = $self->{SPC_m1_srcregion_XLength}\n";
	print "SPC_m1_srcregion_YLength = $self->{SPC_m1_srcregion_YLength}\n";
	print "SPC_m1_bkgregion_X = $self->{SPC_m1_bkgregion_X}\n";
	print "SPC_m1_bkgregion_Y = $self->{SPC_m1_bkgregion_Y}\n";
	print "SPC_m1_bkgregion_R1 = $self->{SPC_m1_bkgregion_R1}\n";
	print "SPC_m1_bkgregion_R2 = $self->{SPC_m1_bkgregion_R2}\n";
	print "SPC_m1_bkgregion_XLength = $self->{SPC_m1_bkgregion_XLength}\n";
	print "SPC_m1_bkgregion_YLength = $self->{SPC_m1_bkgregion_YLength}\n";
	print "SPC_m1_areafactor = $self->{SPC_m1_areafactor}\n";
	print "SPC_m2_srcregion = $self->{SPC_m2_srcregion}\n";
	print "SPC_m2_bkgregion = $self->{SPC_m2_bkgregion}\n";
	print "SPC_m2_srcregion_X = $self->{SPC_m2_srcregion_X}\n";
	print "SPC_m2_srcregion_Y = $self->{SPC_m2_srcregion_Y}\n";
	print "SPC_m2_srcregion_R1 = $self->{SPC_m2_srcregion_R1}\n";
	print "SPC_m2_srcregion_R2 = $self->{SPC_m2_srcregion_R2}\n";
	print "SPC_m2_srcregion_XLength = $self->{SPC_m2_srcregion_XLength}\n";
	print "SPC_m2_srcregion_YLength = $self->{SPC_m2_srcregion_YLength}\n";
	print "SPC_m2_bkgregion_X = $self->{SPC_m2_bkgregion_X}\n";
	print "SPC_m2_bkgregion_Y = $self->{SPC_m2_bkgregion_Y}\n";
	print "SPC_m2_bkgregion_R1 = $self->{SPC_m2_bkgregion_R1}\n";
	print "SPC_m2_bkgregion_R2 = $self->{SPC_m2_bkgregion_R2}\n";
	print "SPC_m2_bkgregion_XLength = $self->{SPC_m2_bkgregion_XLength}\n";
	print "SPC_m2_bkgregion_YLength = $self->{SPC_m2_bkgregion_YLength}\n";
	print "SPC_m2_areafactor = $self->{SPC_m2_areafactor}\n";
	print "SPC_pn_src_expr = $self->{SPC_pn_src_expr}\n";
	print "SPC_pn_bkg_expr = $self->{SPC_pn_bkg_expr}\n";
	print "SPC_m1_src_expr = $self->{SPC_m1_src_expr}\n";
	print "SPC_m1_bkg_expr = $self->{SPC_m1_bkg_expr}\n";
	print "SPC_m2_src_expr = $self->{SPC_m2_src_expr}\n";
	print "SPC_m2_bkg_expr = $self->{SPC_m2_bkg_expr}\n";
	print "LC_rgs1_orders = $self->{LC_rgs1_orders}\n";	
	print "LC_rgs1_timebinsize = $self->{LC_rgs1_timebinsize}\n";
	print "LC_rgs2_orders = $self->{LC_rgs2_orders}\n";
	print "LC_rgs2_timebinsize = $self->{LC_rgs2_timebinsize}\n";
	print "RGS_withsrc = $self->{RGS_withsrc}\n";
	print "RGS_srcstyle = $self->{RGS_srcstyle}\n";
	print "RGS_srcra = $self->{RGS_srcra}\n";
	print "RGS_srcdec = $self->{RGS_srcdec}\n";
	print "RGS_srcdisp = $self->{RGS_srcdisp}\n";
	print "RGS_srcxdsp = $self->{RGS_srcxdsp}\n";
	print "RGS_srclabel = $self->{RGS_srclabel}\n";
	print "RGS_srcrate = $self->{RGS_srcrate}\n";
	print "RGS_keepcool = $self->{RGS_keepcool}\n";
	print "RGS_rejflags = $self->{RGS_rejflags}\n";
	print "RGS_spectrumbinnig = $self->{RGS_spectrumbinnig}\n";	
	print "---> psechain variables <----\n";
}



##############################################
## methods to access per-object data        ##
##                                          ##
## With args, they set the value.  Without  ##
## any, they only retrieve it/them.         ## 
##############################################

sub SRC_Name {
    my $self = shift;
    if (@_) { $self->{SRC_Name}  = shift }
    return $self->{SRC_Name};
}
sub SRC_OBSID {
    my $self = shift;
    if (@_) { $self->{SRC_OBSID}  = shift }
    return $self->{SRC_OBSID};
}
sub SRC_EXP {
    my $self = shift;
    if (@_) { $self->{SRC_EXP}  = shift }
    return $self->{SRC_EXP};
}
sub SRC_RA {
    my $self = shift;
    if (@_) { $self->{SRC_RA}  = shift }
    return $self->{SRC_RA};
}
sub SRC_DEC {
    my $self = shift;
    if (@_) { $self->{SRC_DEC}  = shift }
    return $self->{SRC_DEC};
}

sub EDC_sourcematch {
    my $self = shift;
    if (@_) { $self->{EDC_sourcematch}  = shift }
    return $self->{EDC_sourcematch};
}
sub EDC_cameramatch {
    my $self = shift;
    if (@_) { $self->{EDC_cameramatch}  = shift }
    return $self->{EDC_cameramatch};
}
sub EDC_pn_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_pn_ene_low} } = @_ }
    return @{ $self->{EDC_pn_ene_low} };
}
sub EDC_pn_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_pn_ene_high} } = @_ }
    return @{ $self->{EDC_pn_ene_high} };
}
sub EDC_m1_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m1_ene_low} } = @_ }
    return @{ $self->{EDC_m1_ene_low} };
}
sub EDC_m1_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m1_ene_high} } = @_ }
    return @{ $self->{EDC_m1_ene_high} };
}
sub EDC_m2_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m2_ene_low} } = @_ }
    return @{ $self->{EDC_m2_ene_low} };
}
sub EDC_m2_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m2_ene_high} } = @_ }
    return @{ $self->{EDC_m2_ene_high} };
}
sub EDC_pn_likelihood_detection {
    my $self = shift; 
    if (@_) { $self->{EDC_pn_likelihood_detection} = shift }
    return $self->{EDC_pn_likelihood_detection};
}
sub EDC_mos_likelihood_detection {
    my $self = shift; 
    if (@_) { $self->{EDC_mos_likelihood_detection} = shift }
    return $self->{EDC_mos_likelihood_detection};
}
sub OM_sourcematch {
    my $self = shift; 
    if (@_) { $self->{OM_sourcematch} = shift }
    return $self->{OM_sourcematch};
}
sub GTI_optimize_SN_flag {
    my $self = shift; 
    if (@_) { $self->{GTI_optimize_SN_flag} = shift }
    return $self->{GTI_optimize_SN_flag};
}
sub GTI_mos1energy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_mos1energy_cut} = shift }
    return $self->{GTI_mos1energy_cut};
}
sub GTI_mos2energy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_mos2energy_cut} = shift }
    return $self->{GTI_mos2energy_cut};
}
sub GTI_pnenergy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_pnenergy_cut} = shift }
    return $self->{GTI_pnenergy_cut};
}
sub GTI_MOS1_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_MOS1_Rate} = shift }
    return $self->{GTI_MOS1_Rate};
}
sub GTI_MOS2_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_MOS2_Rate} = shift }
    return $self->{GTI_MOS2_Rate};
}
sub GTI_PN_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_PN_Rate} = shift }
    return $self->{GTI_PN_Rate};
}
sub GTI_timebin {
    my $self = shift; 
    if (@_) { $self->{GTI_timebin} = shift }
    return $self->{GTI_timebin};
}
sub PG_timebinning{
    my $self = shift; 
    if (@_) { $self->{PG_timebinning} = shift }
    return $self->{PG_timebinning};
}
sub PG_timestart{
    my $self = shift; 
    if (@_) { $self->{PG_timestart} = shift }
    return $self->{PG_timestart};
}
sub PG_timeend{
    my $self = shift; 
    if (@_) { $self->{PG_timeend} = shift }
    return $self->{PG_timeend};
}
sub PG_minpi{
    my $self = shift; 
    if (@_) { $self->{PG_minpi} = shift }
    return $self->{PG_minpi};
}      
sub PG_maxpi{
    my $self = shift; 
    if (@_) { $self->{PG_maxpi} = shift }
    return $self->{PG_maxpi};
}      
sub PG_aringcx{
    my $self = shift; 
    if (@_) { $self->{PG_aringcx} = shift }
    return $self->{PG_aringcx};
}    
sub PG_aringcy{
    my $self = shift; 
    if (@_) { $self->{PG_aringcy} = shift }
    return $self->{PG_aringcy};
}    
sub PG_innerrad{
    my $self = shift; 
    if (@_) { $self->{PG_innerrad} = shift }
    return $self->{PG_innerrad};
}   
sub PG_outerrad{
    my $self = shift; 
    if (@_) { $self->{PG_outerrad} = shift }
    return $self->{PG_outerrad};
}   
sub PG_sx{
    my $self = shift; 
    if (@_) { $self->{PG_sx} = shift }
    return $self->{PG_sx};
}         
sub PG_sy{
    my $self = shift; 
    if (@_) { $self->{PG_sy} = shift }
    return $self->{PG_sy};
}         
sub PG_source_rad{
    my $self = shift; 
    if (@_) { $self->{PG_source_rad} = shift }
    return $self->{PG_source_rad};
}
sub PG_areafactor{
    my $self = shift; 
    if (@_) { $self->{PG_areafactor} = shift }
    return $self->{PG_areafactor};
}
sub PG_bkg_region{
    my $self = shift; 
    if (@_) { $self->{PG_bkg_region} = shift }
    return $self->{PG_bkg_region};
}
sub PG_src_region{
    my $self = shift; 
    if (@_) { $self->{PG_src_region} = shift }
    return $self->{PG_src_region};
}

sub LC_pn_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_e1_low} = shift }
    return $self->{LC_pn_e1_low};
}  
sub LC_pn_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_e1_up} = shift }
    return $self->{LC_pn_e1_up};
}  
  
sub LC_m1_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_e1_low} = shift }
    return $self->{LC_m1_e1_low};
}  
sub LC_m1_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_e1_up} = shift }
    return $self->{LC_m1_e1_up};
}  
  
sub LC_m2_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_e1_low} = shift }
    return $self->{LC_m2_e1_low};
}  
sub LC_m2_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_e1_up} = shift }
    return $self->{LC_m2_e1_up};
}  
  
sub LC_pn_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion} = shift }
    return $self->{LC_pn_srcregion};
}          
sub LC_pn_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion} = shift }
    return $self->{LC_pn_bkgregion};
}    
sub LC_pn_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_X} = shift }
    return $self->{LC_pn_srcregion_X};
}    
sub LC_pn_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_Y} = shift }
    return $self->{LC_pn_srcregion_Y};
}    
sub LC_pn_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_R1} = shift }
    return $self->{LC_pn_srcregion_R1};
}    
sub LC_pn_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_R2} = shift }
    return $self->{LC_pn_srcregion_R2};
}    
sub LC_pn_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_XLength} = shift }
    return $self->{LC_pn_srcregion_XLength};
}    
sub LC_pn_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_YLength} = shift }
    return $self->{LC_pn_srcregion_YLength};
}    
sub LC_pn_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_X} = shift }
    return $self->{LC_pn_bkgregion_X};
}    
sub LC_pn_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_Y} = shift }
    return $self->{LC_pn_bkgregion_Y};
}      
sub LC_pn_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_R1} = shift }
    return $self->{LC_pn_bkgregion_R1};
}    
sub LC_pn_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_R2} = shift }
    return $self->{LC_pn_bkgregion_R2};
}    
sub LC_pn_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_XLength} = shift }
    return $self->{LC_pn_bkgregion_XLength};
}    
sub LC_pn_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_YLength} = shift }
    return $self->{LC_pn_bkgregion_YLength};
}    
sub LC_pn_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_areafactor} = shift }
    return $self->{LC_pn_areafactor};
}        

sub LC_m1_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion} = shift }
    return $self->{LC_m1_srcregion};
}          
sub LC_m1_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion} = shift }
    return $self->{LC_m1_bkgregion};
}    
sub LC_m1_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_X} = shift }
    return $self->{LC_m1_srcregion_X};
}    
sub LC_m1_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_Y} = shift }
    return $self->{LC_m1_srcregion_Y};
}    
sub LC_m1_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_R1} = shift }
    return $self->{LC_m1_srcregion_R1};
}    
sub LC_m1_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_R2} = shift }
    return $self->{LC_m1_srcregion_R2};
}    
sub LC_m1_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_XLength} = shift }
    return $self->{LC_m1_srcregion_XLength};
}    
sub LC_m1_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_YLength} = shift }
    return $self->{LC_m1_srcregion_YLength};
}    
sub LC_m1_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_X} = shift }
    return $self->{LC_m1_bkgregion_X};
}    
sub LC_m1_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_Y} = shift }
    return $self->{LC_m1_bkgregion_Y};
}    
sub LC_m1_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_R1} = shift }
    return $self->{LC_m1_bkgregion_R1};
}    
sub LC_m1_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_R2} = shift }
    return $self->{LC_m1_bkgregion_R2};
}    
sub LC_m1_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_XLength} = shift }
    return $self->{LC_m1_bkgregion_XLength};
}    
sub LC_m1_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_YLength} = shift }
    return $self->{LC_m1_bkgregion_YLength};
}    
sub LC_m1_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_areafactor} = shift }
    return $self->{LC_m1_areafactor};
}        

sub LC_m2_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion} = shift }
    return $self->{LC_m2_srcregion};
}          
sub LC_m2_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion} = shift }
    return $self->{LC_m2_bkgregion};
}    
sub LC_m2_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_X} = shift }
    return $self->{LC_m2_srcregion_X};
}    
sub LC_m2_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_Y} = shift }
    return $self->{LC_m2_srcregion_Y};
}    
sub LC_m2_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_R1} = shift }
    return $self->{LC_m2_srcregion_R1};
}    
sub LC_m2_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_R2} = shift }
    return $self->{LC_m2_srcregion_R2};
}    
sub LC_m2_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_XLength} = shift }
    return $self->{LC_m2_srcregion_XLength};
}    
sub LC_m2_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_YLength} = shift }
    return $self->{LC_m2_srcregion_YLength};
}    
sub LC_m2_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_X} = shift }
    return $self->{LC_m2_bkgregion_X};
}    
sub LC_m2_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_Y} = shift }
    return $self->{LC_m2_bkgregion_Y};
}    
sub LC_m2_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_R1} = shift }
    return $self->{LC_m2_bkgregion_R1};
}    
sub LC_m2_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_R2} = shift }
    return $self->{LC_m2_bkgregion_R2};
}    
sub LC_m2_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_XLength} = shift }
    return $self->{LC_m2_bkgregion_XLength};
}    
sub LC_m2_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_YLength} = shift }
    return $self->{LC_m2_bkgregion_YLength};
}    
sub LC_m2_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_areafactor} = shift }
    return $self->{LC_m2_areafactor};
}        


sub SPC_pn_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion} = shift }
    return $self->{SPC_pn_srcregion};
}          
sub SPC_pn_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion} = shift }
    return $self->{SPC_pn_bkgregion};
}    
sub SPC_pn_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_X} = shift }
    return $self->{SPC_pn_srcregion_X};
}    
sub SPC_pn_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_Y} = shift }
    return $self->{SPC_pn_srcregion_Y};
}    
sub SPC_pn_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_R1} = shift }
    return $self->{SPC_pn_srcregion_R1};
}    
sub SPC_pn_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_R2} = shift }
    return $self->{SPC_pn_srcregion_R2};
}    
sub SPC_pn_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_XLength} = shift }
    return $self->{SPC_pn_srcregion_XLength};
}    
sub SPC_pn_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_YLength} = shift }
    return $self->{SPC_pn_srcregion_YLength};
}    
sub SPC_pn_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_X} = shift }
    return $self->{SPC_pn_bkgregion_X};
}    
sub SPC_pn_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_Y} = shift }
    return $self->{SPC_pn_bkgregion_Y};
}      
sub SPC_pn_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_R1} = shift }
    return $self->{SPC_pn_bkgregion_R1};
}    
sub SPC_pn_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_R2} = shift }
    return $self->{SPC_pn_bkgregion_R2};
}    
sub SPC_pn_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_XLength} = shift }
    return $self->{SPC_pn_bkgregion_XLength};
}    
sub SPC_pn_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_YLength} = shift }
    return $self->{SPC_pn_bkgregion_YLength};
}    
sub SPC_pn_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_areafactor} = shift }
    return $self->{SPC_pn_areafactor};
}        

sub SPC_m1_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion} = shift }
    return $self->{SPC_m1_srcregion};
}          
sub SPC_m1_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion} = shift }
    return $self->{SPC_m1_bkgregion};
}    
sub SPC_m1_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_X} = shift }
    return $self->{SPC_m1_srcregion_X};
}    
sub SPC_m1_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_Y} = shift }
    return $self->{SPC_m1_srcregion_Y};
}    
sub SPC_m1_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_R1} = shift }
    return $self->{SPC_m1_srcregion_R1};
}    
sub SPC_m1_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_R2} = shift }
    return $self->{SPC_m1_srcregion_R2};
}    
sub SPC_m1_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_XLength} = shift }
    return $self->{SPC_m1_srcregion_XLength};
}    
sub SPC_m1_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_YLength} = shift }
    return $self->{SPC_m1_srcregion_YLength};
}    
sub SPC_m1_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_X} = shift }
    return $self->{SPC_m1_bkgregion_X};
}    
sub SPC_m1_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_Y} = shift }
    return $self->{SPC_m1_bkgregion_Y};
}    
sub SPC_m1_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_R1} = shift }
    return $self->{SPC_m1_bkgregion_R1};
}    
sub SPC_m1_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_R2} = shift }
    return $self->{SPC_m1_bkgregion_R2};
}    
sub SPC_m1_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_XLength} = shift }
    return $self->{SPC_m1_bkgregion_XLength};
}    
sub SPC_m1_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_YLength} = shift }
    return $self->{SPC_m1_bkgregion_YLength};
}    
sub SPC_m1_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_areafactor} = shift }
    return $self->{SPC_m1_areafactor};
}        

sub SPC_m2_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion} = shift }
    return $self->{SPC_m2_srcregion};
}          
sub SPC_m2_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion} = shift }
    return $self->{SPC_m2_bkgregion};
}    
sub SPC_m2_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_X} = shift }
    return $self->{SPC_m2_srcregion_X};
}    
sub SPC_m2_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_Y} = shift }
    return $self->{SPC_m2_srcregion_Y};
}    
sub SPC_m2_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_R1} = shift }
    return $self->{SPC_m2_srcregion_R1};
}    
sub SPC_m2_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_R2} = shift }
    return $self->{SPC_m2_srcregion_R2};
}    
sub SPC_m2_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_XLength} = shift }
    return $self->{SPC_m2_srcregion_XLength};
}    
sub SPC_m2_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_YLength} = shift }
    return $self->{SPC_m2_srcregion_YLength};
}    
sub SPC_m2_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_X} = shift }
    return $self->{SPC_m2_bkgregion_X};
}    
sub SPC_m2_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_Y} = shift }
    return $self->{SPC_m2_bkgregion_Y};
}    
sub SPC_m2_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_R1} = shift }
    return $self->{SPC_m2_bkgregion_R1};
}    
sub SPC_m2_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_R2} = shift }
    return $self->{SPC_m2_bkgregion_R2};
}    
sub SPC_m2_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_XLength} = shift }
    return $self->{SPC_m2_bkgregion_XLength};
}    
sub SPC_m2_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_YLength} = shift }
    return $self->{SPC_m2_bkgregion_YLength};
}    
sub SPC_m2_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_areafactor} = shift }
    return $self->{SPC_m2_areafactor};
}        

sub LC_rgs1_orders{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs1_orders} = shift }
    return $self->{LC_rgs1_orders};
} 


sub LC_rgs1_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs1_timebinsize} = shift }
    return $self->{LC_rgs1_timebinsize};
}

sub LC_rgs2_orders{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs2_orders} = shift }
    return $self->{LC_rgs2_orders};
} 


sub LC_rgs2_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs2_timebinsize} = shift }
    return $self->{LC_rgs2_timebinsize};
}

sub PN{ 
    my $self = shift; 
    if (@_) { $self->{PN} = shift }
    return $self->{PN};
}

sub MOS{ 
    my $self = shift; 
    if (@_) { $self->{MOS} = shift }
    return $self->{MOS};
}

sub RGS{ 
    my $self = shift; 
    if (@_) { $self->{RGS} = shift }
    return $self->{RGS};
}

sub OM{ 
    my $self = shift; 
    if (@_) { $self->{OM} = shift }
    return $self->{OM};
}

sub pn_interactive{ 
    my $self = shift; 
    if (@_) { $self->{pn_interactive} = shift }
    return $self->{pn_interactive};
}

sub mos1_interactive{ 
    my $self = shift; 
    if (@_) { $self->{mos1_interactive} = shift }
    return $self->{mos1_interactive};
}

sub mos2_interactive{ 
    my $self = shift; 
    if (@_) { $self->{mos2_interactive} = shift }
    return $self->{mos2_interactive};
}

sub ANA_epatplot{ 
    my $self = shift; 
    if (@_) { $self->{ANA_epatplot} = shift }
    return $self->{ANA_epatplot};
}
 
sub SPC_pn_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_src_expr} = shift }
    return $self->{SPC_pn_src_expr};
}

sub SPC_pn_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkg_expr} = shift }
    return $self->{SPC_pn_bkg_expr};
}

sub SPC_m1_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_src_expr} = shift }
    return $self->{SPC_m1_src_expr};
}
sub SPC_m1_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkg_expr} = shift }
    return $self->{SPC_m1_bkg_expr};
}
sub SPC_m2_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_src_expr} = shift }
    return $self->{SPC_m2_src_expr};
}
sub SPC_m2_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkg_expr} = shift }
    return $self->{SPC_m2_bkg_expr};
}

sub SPC_pn_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_src_ds9region_file} = shift }
    return $self->{SPC_pn_src_ds9region_file};
}

sub SPC_pn_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkg_ds9region_file} = shift }
    return $self->{SPC_pn_bkg_ds9region_file};
}

sub SPC_m1_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_src_ds9region_file} = shift }
    return $self->{SPC_m1_src_ds9region_file};
}
sub SPC_m1_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkg_ds9region_file} = shift }
    return $self->{SPC_m1_bkg_ds9region_file};
}
sub SPC_m2_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_src_ds9region_file} = shift }
    return $self->{SPC_m2_src_ds9region_file};
}
sub SPC_m2_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkg_ds9region_file} = shift }
    return $self->{SPC_m2_bkg_ds9region_file};
}
 
sub LC_pn_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_src_expr} = shift }
    return $self->{LC_pn_src_expr};
}

sub LC_pn_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkg_expr} = shift }
    return $self->{LC_pn_bkg_expr};
}

sub LC_m1_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_src_expr} = shift }
    return $self->{LC_m1_src_expr};
}
sub LC_m1_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkg_expr} = shift }
    return $self->{LC_m1_bkg_expr};
}
sub LC_m2_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_src_expr} = shift }
    return $self->{LC_m2_src_expr};
}
sub LC_m2_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkg_expr} = shift }
    return $self->{LC_m2_bkg_expr};
}
 
 
 sub LC_pn_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_timebinsize} = shift }
    return $self->{LC_pn_timebinsize};
}

sub LC_m1_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_timebinsize} = shift }
    return $self->{LC_m1_timebinsize};
}

sub LC_m2_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_timebinsize} = shift }
    return $self->{LC_m2_timebinsize};
}

sub RGS_withsrc{ 
    my $self = shift; 
    if (@_) { $self->{RGS_withsrc} = shift }
    return $self->{RGS_withsrc};
}

sub RGS_srcstyle{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcstyle} = shift }
    return $self->{RGS_srcstyle};
}

sub RGS_srcra{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcra} = shift }
    return $self->{RGS_srcra};
}

sub RGS_srcdec{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcdec} = shift }
    return $self->{RGS_srcdec};
}

sub RGS_srcdisp{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcdisp} = shift }
    return $self->{RGS_srcdisp};
}

sub RGS_srcxdsp{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcxdsp} = shift }
    return $self->{RGS_srcxdsp};
}

sub RGS_srclabel{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srclabel} = shift }
    return $self->{RGS_srclabel};
}

sub RGS_srcrate{ 
    my $self = shift; 
    if (@_) { $self->{RGS_srcrate} = shift }
    return $self->{RGS_srcrate};
}	

sub RGS_keepcool{ 
    my $self = shift; 
    if (@_) { $self->{RGS_keepcool} = shift }
    return $self->{RGS_keepcool};
}	

sub RGS_rejflags{ 
    my $self = shift; 
    if (@_) { $self->{RGS_rejflags} = shift }
    return $self->{RGS_rejflags};
}		
	
sub RGS_spectrumbinnig{ 
    my $self = shift; 
    if (@_) { $self->{RGS_spectrumbinnig} = shift }
    return $self->{RGS_spectrumbinnig};
}		

1;
