## @file
# Define Analysis Main Structure

#========================================================================
sub obsid_structure(){

    use vars qw(%obsid_instruments);
        
    my $source_obsID = $gv->SRC_OBSID;
    
    $obsid_instruments{$source_obsID}{'pn'}{'instrument'}     ="pn";       # Init main structure fields
    $obsid_instruments{$source_obsID}{'pn'}{'obsid'}          =$source_obsID;       
    $obsid_instruments{$source_obsID}{'pn'}{'date'}           ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'starting_time'}  ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'ending_time'}    ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'duration'}       ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'ontime'}         ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'livetime'}       ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'mode'}           ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'submode'}        ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'filter'}         ='unknown';
    $obsid_instruments{$source_obsID}{'pn'}{'exposure'}       ='unknown';

    $obsid_instruments{$source_obsID}{'mos1'}{'instrument'}   ="mos1";
    $obsid_instruments{$source_obsID}{'mos1'}{'obsid'}        =$source_obsID;
    $obsid_instruments{$source_obsID}{'mos1'}{'date'}         ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'starting_time'}='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'ending_time'}  ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'duration'}     ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'ontime'}       ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'livetime'}     ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'mode'}         ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'submode'}      ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'filter'}       ='unknown';
    $obsid_instruments{$source_obsID}{'mos1'}{'exposure'}     ='unknown';


    $obsid_instruments{$source_obsID}{'mos2'}{'instrument'}   ="mos2";
    $obsid_instruments{$source_obsID}{'mos2'}{'obsid'}        =$source_obsID;
    $obsid_instruments{$source_obsID}{'mos2'}{'date'}         ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'starting_time'}='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'ending_time'}  ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'duration'}     ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'ontime'}       ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'livetime'}     ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'mode'}         ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'submode'}      ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'filter'}       ='unknown';
    $obsid_instruments{$source_obsID}{'mos2'}{'exposure'}     ='unknown';

    $obsid_instruments{$source_obsID}{'rgs'}{'instrument'}    ="rgs";
    $obsid_instruments{$source_obsID}{'rgs'}{'obsid'}         =$source_obsID;
    $obsid_instruments{$source_obsID}{'rgs'}{'date'}          ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'starting_time'} ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'ending_time'}   ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'duration'}      ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'ontime'}        ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'livetime'}      ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'mode'}          ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'submode'}       ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'filter'}        ='unknown';
    $obsid_instruments{$source_obsID}{'rgs'}{'exposure'}      ='unknown';


    $obsid_instruments{$source_obsID}{'om'}{'instrument'}     ="om";
    $obsid_instruments{$source_obsID}{'om'}{'obsid'}          =$source_obsID;
    $obsid_instruments{$source_obsID}{'om'}{'date'}           ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'starting_time'}  ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'ending_time'}    ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'duration'}       ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'ontime'}         ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'livetime'}       ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'mode'}           ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'submode'}        ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'filter'}         ='unknown';
    $obsid_instruments{$source_obsID}{'om'}{'exposure'}       ='unknown';
    
    return(1);
}

## @method void fill_structure($obsid,$instr,$field,$value)
# Fills the value of a given field in the obsid structure
# @param obsid Observation ID
# @param instr Instrument
# @param field Field in the Structure to be filled
# @param value Value of the Field 
# @return Void

#========================================================================
sub fill_structure(){

    my $obsid=$_[0];
    my $instr=$_[1];
    my $field=$_[2];
    my $value=$_[3];
    
    $obsid_instruments{$obsid}{$instr}{$field}=$value;
    
    return(1);
}

## @method void print_obsid_instruments($obsid,$instr,$field)
# Prints the value of a given field in the obsid structure
# @param obsid Observation ID
# @param instr Instrument
# @param field Field in the Structure to be printed
# @return Void

#========================================================================
sub print_obsid_instruments(){

    my $obs;
    my $instr;
    my $field;
    
    print " \n";
    print "----> OBSID Instrument Structure Information \n";
    print " \n";
    if ($Log_Flag == 0) {
	print MYOUTFILE " \n";
	print MYOUTFILE "----> OBSID Instrument Structure Information \n";
	print MYOUTFILE " \n";
    }
    for $obs ( keys %obsid_instruments) {
	for $instr ( keys %{ $obsid_instruments{$obs}} ) {
	    for $field ( keys %{ $obsid_instruments{$obs}{$instr} } ) {
		print "$obs : $instr : $field : $obsid_instruments{$obs}{$instr}{$field} \n";
		if ($Log_Flag == 0) {print MYOUTFILE "$obs: $instr : $field : $obsid_instruments{$obs}{$instr}{$field} \n";}
	    }
	    print " \n";
	    if ($Log_Flag == 0) {print MYOUTFILE "\n";}
	}
    }
    
    return(1);
}
1;
