## @file
# Initialize analysis parameters

#========================================================================
sub parameters_init(){

#.. Read Script Options
    my $name="psechain";
    my $line="@ARGV"; 
    my @save;
    my $source_name; my $source_obsID; my $source_ra; my $source_dec;
    if ( @save = grep /^\-p/ , @ARGV) {
       &usage();
    };

    if ( @save = grep /^-d/ , @ARGV) {
	     system("sasdialog $name");
		 my $x = $? >> 8;
    	 exit($x);      
    }

    if ( @save = grep /^-v/ , @ARGV) {
		&getVersion();
    }


#.. Default parameters (Start)

    if ( @save = grep /^sourcename=/ , @ARGV) {
       $source_name="$save[-1]";
       $source_name =~ s/^.*=//; 
       $source_name =~ s/\+/\_/;              
    }else { &error_code(100); }

    if ( @save = grep /^obsid=/ , @ARGV) {
      $source_obsID  ="$save[-1]";
      $source_obsID  =~ s/^.*=//; 
    }else { &error_code(101); }

    if ( @save = grep /^ra=/ , @ARGV) {
       $source_ra ="$save[-1]";
       $source_ra  =~ s/^.*=//; 
    } else { $source_ra=-999; }

    if ( @save = grep /^dec=/ , @ARGV) {
       $source_dec ="$save[-1]";
       $source_dec  =~ s/^.*=//; 
    } else { $source_dec=-999; }

    if ( @save = grep /^analysisoption=/ , @ARGV) {
       $analysis_action ="$save[-1]";
       $analysis_action =~ s/^.*=//; 
    } else { $analysis_action=0; }

    if ( @save = grep /^PN=/ , @ARGV) {
       $PN ="$save[-1]";
       $PN =~ s/^.*=//; 
    } else { $PN="yes"; }

    if ( @save = grep /^MOS=/ , @ARGV) {
       $MOS ="$save[-1]";
       $MOS =~ s/^.*=//; 
    } else { $MOS="yes"; }

    if ( @save = grep /^RGS=/ , @ARGV) {
       $RGS ="$save[-1]";
       $RGS =~ s/^.*=//; 
    } else { $RGS="yes"; }

    if ( @save = grep /^OM=/ , @ARGV) {
       $OM ="$save[-1]";
       $OM =~ s/^.*=//; 
    } else { $OM="yes"; }

    if ( @save = grep /^pn_interactive=/ , @ARGV) {
       $pn_interactive ="$save[-1]";
       $pn_interactive =~ s/^.*=//; 
    } else { $pn_interactive="no"; }

    if ( @save = grep /^mos1_interactive=/ , @ARGV) {
       $mos1_interactive ="$save[-1]";
       $mos1_interactive =~ s/^.*=//; 
    } else { $mos1_interactive="no"; }

    if ( @save = grep /^mos2_interactive=/ , @ARGV) {
       $mos2_interactive ="$save[-1]";
       $mos2_interactive =~ s/^.*=//; 
    } else { $mos2_interactive="no"; }


   if ( @save = grep /^runepatplot=/ , @ARGV) {
       $runepatplot ="$save[-1]";
       $runepatplot =~ s/^.*=//; 
    } else { $runepatplot=0; }

#.. Default parameters (End)

#.. Compute GTI user option (Start)

   if ( @save = grep /^mos1energy_cut=/ , @ARGV) {
       $mos1energy_cut ="$save[-1]";
       $mos1energy_cut =~ s/^.*=//; 
    } else { $mos1energy_cut=0; }

   if ( @save = grep /^mos2energy_cut=/ , @ARGV) {
       $mos2energy_cut ="$save[-1]";
       $mos2energy_cut =~ s/^.*=//; 
    } else { $mos2energy_cut=0; }

   if ( @save = grep /^pnenergy_cut=/ , @ARGV) {
       $pnenergy_cut ="$save[-1]";
       $pnenergy_cut =~ s/^.*=//; 
    } else { $pnenergy_cut=0; }
   
   if ( @save = grep /^MOS1_Rate=/ , @ARGV) {
       $MOS1_Rate ="$save[-1]";
       $MOS1_Rate =~ s/^.*=//; 
    } else { $MOS1_Rate=0; }

   if ( @save = grep /^MOS2_Rate=/ , @ARGV) {
       $MOS2_Rate ="$save[-1]";
       $MOS2_Rate =~ s/^.*=//; 
    } else { $MOS2_Rate=0; }

   if ( @save = grep /^PN_Rate=/ , @ARGV) {
       $PN_Rate ="$save[-1]";
       $PN_Rate =~ s/^.*=//; 
    } else { $PN_Rate=0; }

   if ( @save = grep /^timebin=/ , @ARGV) {
       $timebin ="$save[-1]";
       $timebin =~ s/^.*=//; 
    } else { $timebin=0; }
     
   if ( @save = grep /^PG_optimize_SN=/ , @ARGV) {
       $PG_optimize_SN ="$save[-1]";
       $PG_optimize_SN =~ s/^.*=//; 
    } else { $PG_optimize_SN="no"; }

#.. Compute GTI user options (End)

#.. edetect chain user options (Start)

  if ( @save = grep /^pn_ene_low=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//; 
       @pn_ene_low = split/\,/,$temp;
    } else { @pn_ene_low=(0,0,0,0,0); }
    
  if ( @save = grep /^pn_ene_high=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//;
       @pn_ene_high  = split/\,/,$temp; 
    } else { @pn_ene_high=(0,0,0,0,0); }

  if ( @save = grep /^m1_ene_high=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//; 
       @m1_ene_high = split/\,/,$temp;
    } else { @m1_ene_high=(0,0,0,0,0); }

  if ( @save = grep /^m1_ene_low=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//; 
       @m1_ene_low = split/\,/,$temp;
    } else { @m1_ene_low=(0,0,0,0,0); }

  if ( @save = grep /^m2_ene_high=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//;
       @m2_ene_high = split/\,/,$temp; 
    } else { @m2_ene_high=(0,0,0,0,0); }
    
  if ( @save = grep /^m2_ene_low=/ , @ARGV) {
       $temp ="$save[-1]";
       $temp =~ s/^.*=//;
       @m2_ene_low = split/\,/,$temp; 
    } else { @m2_ene_low=(0,0,0,0,0); }
    
  if ( @save = grep /^pn_likelihood_detection=/ , @ARGV) {
       $pn_likelihood_detection ="$save[-1]";
       $pn_likelihood_detection =~ s/^.*=//; 
    } else { $pn_likelihood_detection=0; }

  if ( @save = grep /^mos_likelihood_detection=/ , @ARGV) {
       $mos_likelihood_detection="$save[-1]";
       $mos_likelihood_detection=~ s/^.*=//; 
    } else { $mos_likelihood_detection=0; }

  if ( @save = grep /^sourcematch=/ , @ARGV) {
       $sourcematch ="$save[-1]";
       $sourcematch =~ s/^.*=//; 
    } else { $sourcematch=0; }

  if ( @save = grep /^cameramatch=/ , @ARGV) {
       $cameramatch="$save[-1]";
       $cameramatch=~ s/^.*=//; 
    } else { $cameramatch=0; }

  if ( @save = grep /^om_sourcematch=/ , @ARGV) {
       $om_sourcematch ="$save[-1]";
       $om_sourcematch =~ s/^.*=//; 
    } else { $om_sourcematch=0; }
    
  if ( @save = grep /^SPC_pn_src_expr=/ , @ARGV) {
       $SPC_pn_src_expr ="$save[-1]";
       $SPC_pn_src_expr =~ s/^.*=//; 
    } else { $SPC_pn_src_expr=0; }

  if ( @save = grep /^SPC_pn_bkg_expr=/ , @ARGV) {
       $SPC_pn_bkg_expr ="$save[-1]";
       $SPC_pn_bkg_expr =~ s/^.*=//; 
    } else { $SPC_pn_bkg_expr=0; }
    
 if ( @save = grep /^SPC_m1_src_expr=/ , @ARGV) {
       $SPC_m1_src_expr ="$save[-1]";
       $SPC_m1_src_expr =~ s/^.*=//; 
    } else { $SPC_m1_src_expr=0; }

  if ( @save = grep /^SPC_m1_bkg_expr=/ , @ARGV) {
       $SPC_m1_bkg_expr ="$save[-1]";
       $SPC_m1_bkg_expr =~ s/^.*=//; 
    } else { $SPC_m1_bkg_expr=0; }    

 if ( @save = grep /^SPC_m2_src_expr=/ , @ARGV) {
       $SPC_m2_src_expr ="$save[-1]";
       $SPC_m2_src_expr =~ s/^.*=//; 
    } else { $SPC_m2_src_expr=0; }

  if ( @save = grep /^SPC_m2_bkg_expr=/ , @ARGV) {
       $SPC_m2_bkg_expr ="$save[-1]";
       $SPC_m2_bkg_expr =~ s/^.*=//; 
    } else { $SPC_m2_bkg_expr=0; }
        
    
  if ( @save = grep /^LC_pn_src_expr=/ , @ARGV) {
       $LC_pn_src_expr ="$save[-1]";
       $LC_pn_src_expr =~ s/^.*=//; 
    } else { $LC_pn_src_expr=0; }

  if ( @save = grep /^LC_pn_bkg_expr=/ , @ARGV) {
       $LC_pn_bkg_expr ="$save[-1]";
       $LC_pn_bkg_expr =~ s/^.*=//; 
    } else { $LC_pn_bkg_expr=0; }
    
 if ( @save = grep /^LC_m1_src_expr=/ , @ARGV) {
       $LC_m1_src_expr ="$save[-1]";
       $LC_m1_src_expr =~ s/^.*=//; 
    } else { $LC_m1_src_expr=0; }

  if ( @save = grep /^LC_m1_bkg_expr=/ , @ARGV) {
       $LC_m1_bkg_expr ="$save[-1]";
       $LC_m1_bkg_expr =~ s/^.*=//; 
    } else { $LC_m1_bkg_expr=0; }    

 if ( @save = grep /^LC_m2_src_expr=/ , @ARGV) {
       $LC_m2_src_expr ="$save[-1]";
       $LC_m2_src_expr =~ s/^.*=//; 
    } else { $LC_m2_src_expr=0; }

  if ( @save = grep /^LC_m2_bkg_expr=/ , @ARGV) {
       $LC_m2_bkg_expr ="$save[-1]";
       $LC_m2_bkg_expr =~ s/^.*=//; 
    } else { $LC_m2_bkg_expr=0; }
    
  if ( @save = grep /^LC_pn_timebinsize=/ , @ARGV) {
       $LC_pn_timebinsize ="$save[-1]";
       $LC_pn_timebinsize =~ s/^.*=//; 
    } else { $LC_pn_timebinsize=0; }
 
 if ( @save = grep /^LC_pn_e1_low=/ , @ARGV) {
       $LC_pn_e1_low ="$save[-1]";
       $LC_pn_e1_low =~ s/^.*=//; 
    } else { $LC_pn_e1_low=0; }

 if ( @save = grep /^LC_pn_e1_up=/ , @ARGV) {
       $LC_pn_e1_up ="$save[-1]";
       $LC_pn_e1_up =~ s/^.*=//; 
    } else { $LC_pn_e1_up=0; }

 if ( @save = grep /^LC_m1_timebinsize=/ , @ARGV) {
       $LC_m1_timebinsize ="$save[-1]";
       $LC_m1_timebinsize =~ s/^.*=//; 
    } else { $LC_m1_timebinsize=0; }
    

if ( @save = grep /^LC_m1_e1_low=/ , @ARGV) {
       $LC_m1_e1_low ="$save[-1]";
       $LC_m1_e1_low =~ s/^.*=//; 
    } else { $LC_m1_e1_low=0; }

 if ( @save = grep /^LC_m1_e1_up=/ , @ARGV) {
       $LC_m1_e1_up ="$save[-1]";
       $LC_m1_e1_up =~ s/^.*=//; 
    } else { $LC_m1_e1_up=0; }
 
  if ( @save = grep /^LC_m2_timebinsize=/ , @ARGV) {
       $LC_m2_timebinsize ="$save[-1]";
       $LC_m2_timebinsize =~ s/^.*=//; 
    } else { $LC_m2_timebinsize=0; }
 
    
    if ( @save = grep /^LC_m2_e1_low=/ , @ARGV) {
       $LC_m2_e1_low ="$save[-1]";
       $LC_m2_e1_low =~ s/^.*=//; 
    } else { $LC_m2_e1_low=0; }

 if ( @save = grep /^LC_m2_e1_up=/ , @ARGV) {
       $LC_m2_e1_up ="$save[-1]";
       $LC_m2_e1_up =~ s/^.*=//; 
    } else { $LC_m2_e1_up=0; }
    

 
 

#... RGS parameters
            
   if ( @save = grep /^withsrc=/ , @ARGV) {
       $withsrc ="$save[-1]";
       $withsrc =~ s/^.*=//; 
    } else { $withsrc="no"; }
    
   if ( @save = grep /^srcstyle=/ , @ARGV) {
       $srcstyle ="$save[-1]";
       $srcstyle =~ s/^.*=//; 
    } else { $srcstyle="radec"; }
    
   if ( @save = grep /^srcra=/ , @ARGV) {
       $srcra ="$save[-1]";
       $srcra=~ s/^.*=//; 
    } else { $srcra="-999"; }
    
   if ( @save = grep /^srcdec=/ , @ARGV) {
       $srcdec ="$save[-1]";
       $srcdec=~ s/^.*=//; 
    } else { $srcdec="-999"; }

   if ( @save = grep /^srcdisp=/ , @ARGV) {
       $srcdisp ="$save[-1]";
       $srcdisp=~ s/^.*=//; 
    } else { $srcdisp="0"; }

   if ( @save = grep /^srcxdsp=/ , @ARGV) {
       $srcxdsp ="$save[-1]";
       $srcxdsp=~ s/^.*=//; 
    } else { $srcxdsp="0"; }

  if ( @save = grep /^srclabel=/ , @ARGV) {
       $srclabel ="$save[-1]";
       $srclabel=~ s/^.*=//; 
    } else { $srclabel="USER"; }

   if ( @save = grep /^srcrate=/ , @ARGV) {
       $srcrate ="$save[-1]";
       $srcrate=~ s/^.*=//; 
    } else { $srcrate=0; }

   if ( @save = grep /^keepcool=/ , @ARGV) {
       $keepcool ="$save[-1]";
       $keepcool=~ s/^.*=//; 
    } else { $keepcool=1; }
    
   if ( @save = grep /^rejflags=/ , @ARGV) {
       $rejflags ="$save[-1]";
       $rejflags=~ s/^.*=//; 
    } else { $rejflags="BAD_SHAPE ON_NODE_INTERFACE ON_BADPIX NEXT_TO_BADPIX ON_WINDOW_BORDER BELOW_ACCEPTANCE"; }    

   if ( @save = grep /^spectrumbinning=/ , @ARGV) {
       $spectrumbinning ="$save[-1]";
       $spectrumbinning=~ s/^.*=//; 
    } else { $spectrumbinning="beta"; }    
    
#.. edetect chain user options (End)

#.. Store source OBSID, Name, RA and DEC
    $gv->SRC_OBSID($source_obsID); 
    $gv->SRC_RA($source_ra); 
    $gv->SRC_DEC($source_dec); 
    $gv->SRC_Name($source_name);

	$gv->PN($PN);
	$gv->MOS($MOS);
	$gv->RGS($RGS);
	$gv->OM($OM);
	
	$gv->pn_interactive($pn_interactive);
	$gv->mos1_interactive($mos1_interactive);
	$gv->mos2_interactive($mos2_interactive);
	$gv->ANA_epatplot($runepatplot);

#.. Store Compute GTI user options or initialize default values. 

#.. Parameters for GTI
        
	
	if ($mos1energy_cut != 0) {
	    $gv->GTI_mos1energy_cut($mos1energy_cut); # eV, of energy cut to use for GTI
	} else {
		$gv->GTI_mos1energy_cut(10000);  } # eV, of energy cut to use for GTI	
	if ($mos1energy_cut != 0) {			    
    	$gv->GTI_mos2energy_cut($mos1energy_cut); # eV, of energy cut to use for GTI
	} else {	
		$gv->GTI_mos2energy_cut(10000); } # eV, of energy cut to use for GTI 	
	if($pnenergy_cut != 0) {
	    $gv->GTI_pnenergy_cut($pnenergy_cut);   # eV, of energy cut to use for GTI
	} else {
		$gv->GTI_pnenergy_cut(10000); }  # eV, of energy cut to use for GTI     
	if($MOS1_Rate != 0) {
		$gv->GTI_MOS1_Rate($MOS1_Rate);        # Rate, in c/s, to cut on for GTI
	} else {
    	$gv->GTI_MOS1_Rate(0.8);  }      # Rate, in c/s, to cut on for GTI	    
	if($MOS2_Rate != 0) {
    	$gv->GTI_MOS2_Rate($MOS2_Rate);        # Rate, in c/s, to cut on for GTI
	} else {
		$gv->GTI_MOS2_Rate(0.8);  }      # Rate, in c/s, to cut on for GTI	
	if ($PN_Rate != 0) 	{
	    $gv->GTI_PN_Rate($PN_Rate);           # Rate, in c/s, to cut on for GTI
	} else {
		$gv->GTI_PN_Rate(1.);  }         # Rate, in c/s, to cut on for GTI		
	if ($timebin) { 
	    $gv->GTI_timebin($timebin);          # Time bin to use for GTI light curve
	} else {
	    $gv->GTI_timebin(10.);  }      # Time bin to use for GTI light curve
	 
	$gv->GTI_optimize_SN_flag($PG_optimize_SN);    # Use best S/N to work out GTI. If set to T, use PG_gti_filtering parameters
	
#.. Parameters for PG_gti_filtering (if values are not equal to 0, they will be used. 
#   If values are 0, defaults will be used)
    
    $gv->PG_timebinning(100); # secs; Bin size for src and bkg light curves
    $gv->PG_timestart(0);     # secs; Time of the first event
    $gv->PG_timeend(0);       # secs; Time of the last event
    $gv->PG_minpi(0);         # eV; Minimum event energy to use
    $gv->PG_maxpi(0);         # eV; Maximum event energy to use
    $gv->PG_aringcx(0);       # BACKGROUND ANNULAR REGION. X_center in PHYSICAL PIXELS
    $gv->PG_aringcy(0);       # BACKGROUND ANNULAR REGION. Y_center in PHYSICAL PIXELS
    $gv->PG_innerrad(0);      # BACKGROUND ANNULAR REGION. inner_radius in PHYSICAL PIXELS
    $gv->PG_outerrad(13200);  # BACKGROUND ANNULAR REGION. outer_radius in PHYSICAL PIXELS
    $gv->PG_sx(0);            # SOURCE REGION. X_center in PHYSICAL PIXELS
    $gv->PG_sy(0);            # SOURCE REGION. Y_center in PHYSICAL PIXELS
    $gv->PG_source_rad(400);  # SOURCE REGION. radius in PHYSICAL PIXELS
    $gv->PG_areafactor(0);    # Area Scale Factor (SRC_Area/BKG_Area)
    $gv->PG_src_region("circle"); # Shape of the bkg region
    $gv->PG_bkg_region("annulus"); # Shape of the bkg region

#.. Parameters for Edetect_Chain
    if($pn_ene_low[0] != 0 && $pn_ene_low[4] != 0) {    	
	    $gv->EDC_pn_ene_low($pn_ene_low[0],$pn_ene_low[1],$pn_ene_low[2],$pn_ene_low[3],$pn_ene_low[4]);     # energy in eV
    } else {
    	$gv->EDC_pn_ene_low(300,500,2000,4500,7500);}    # energy in eV 
    if($pn_ene_high[0] != 0 && $pn_ene_high[4] != 0) {    	
	    $gv->EDC_pn_ene_high($pn_ene_high[0],$pn_ene_high[1],$pn_ene_high[2],$pn_ene_high[3],$pn_ene_high[4]);     # energy in eV
    } else {  
    	$gv->EDC_pn_ene_high(500,2000,4500,7500,12000);}  # energy in eV
    if($m1_ene_low[0] != 0 && $m1_ene_low[4] != 0) {    	
	    $gv->EDC_m1_ene_low($m1_ene_low[0],$m1_ene_low[1],$m1_ene_low[2],$m1_ene_low[3],$m1_ene_low[4]);     # energy in eV
    } else {
	    $gv->EDC_m1_ene_low(200,500,2000,4500,7500); }    # energy in eV
    if($m1_ene_high[0] != 0 && $m1_ene_high[4] != 0) {    	
	    $gv->EDC_m1_ene_high($m1_ene_high[0],$m1_ene_high[1],$m1_ene_high[2],$m1_ene_high[3],$m1_ene_high[4]);     # energy in eV
    } else {  
	    $gv->EDC_m1_ene_high(500,2000,4500,7500,12000); }  # energy in eV
    if($m2_ene_low[0] != 0 && $m2_ene_low[4] != 0) {    	
	    $gv->EDC_m2_ene_low($m2_ene_low[0],$m2_ene_low[1],$m2_ene_low[2],$m2_ene_low[3],$m2_ene_low[4]);     # energy in eV
    } else {
	    $gv->EDC_m2_ene_low(200,500,2000,4500,7500); }    # energy in eV
    if($m2_ene_high[0] != 0 && $m2_ene_high[4] != 0) {    	
	    $gv->EDC_m2_ene_high($m2_ene_high[0],$m2_ene_high[1],$m2_ene_high[2],$m2_ene_high[3],$m2_ene_high[4]);     # energy in eV
    } else {  
	    $gv->EDC_m2_ene_high(500,2000,4500,7500,12000); } # energy in eV
    if($pn_likelihood_detection != 0) {
	    $gv->EDC_pn_likelihood_detection($pn_likelihood_detection);
    } else {
    	$gv->EDC_pn_likelihood_detection(10); }
    if ($mos_likelihood_detection != 0 ) {
 	   $gv->EDC_mos_likelihood_detection($mos_likelihood_detection);
    } else {   
    	$gv->EDC_mos_likelihood_detection(10);}
	if($sourcematch != 0) {    	
    	$gv->EDC_sourcematch($sourcematch); 
	} else {
		$gv->EDC_sourcematch(0.001689656258); }  # For source crosscorrelation (deg) (XMM-Newton pos error: 6arcsec)
	if ($cameramatch != 0 ) {		
    	$gv->EDC_cameramatch($cameramatch);
    	print "$cameramatch\n"; 
	} else {
		$gv->EDC_cameramatch(0.0005555555); } # For camera crosscorrelation (deg) (Relative EPIC Camera error: 2arcsec) 

#.. Parameters for OM Source Detection
	if($om_sourcematch != 0 ) {
	    $gv->OM_sourcematch($om_sourcematch);  # For source crosscorrelation (deg)
	} else {
	    $gv->OM_sourcematch(0.000277777); }  # For source crosscorrelation (deg)

    $gv->LC_pn_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->LC_pn_srcregion_X(0.);        # For circle region. 0: default
    $gv->LC_pn_srcregion_Y(0.);        # For circle region. 0: default
    $gv->LC_pn_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_pn_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_pn_srcregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_pn_srcregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_pn_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->LC_pn_bkgregion_X(0.);        # For circle region. 0: default
    $gv->LC_pn_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->LC_pn_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_pn_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: defaultt
    $gv->LC_pn_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_pn_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_pn_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area
    $gv->LC_m1_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->LC_m1_srcregion_X(0.);        # For circle region. 0: default
    $gv->LC_m1_srcregion_Y(0.);        # For circle region. 0: default
    $gv->LC_m1_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: defualt
    $gv->LC_m1_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m1_srcregion_XLength(0.);  # For box region centered in X,Y. 0: automatic box region
    $gv->LC_m1_srcregion_YLength(0.);  # For box region centered in X,Y. 0: automatic box region
    $gv->LC_m1_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->LC_m1_bkgregion_X(0.);        # For circle region. 0: default
    $gv->LC_m1_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->LC_m1_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m1_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m1_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m1_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m1_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area
    $gv->LC_m2_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->LC_m2_srcregion_X(0.);        # For circle region. 0: default
    $gv->LC_m2_srcregion_Y(0.);        # For circle region. 0: default
    $gv->LC_m2_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m2_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m2_srcregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m2_srcregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m2_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->LC_m2_bkgregion_X(0.);        # For circle region. 0: default
    $gv->LC_m2_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->LC_m2_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m2_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->LC_m2_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m2_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->LC_m2_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area

#.. Parameters for Spectrum
	
	if($SPC_pn_src_expr) {
		$gv->SPC_pn_src_expr($SPC_pn_src_expr);
	} else {
		$gv->SPC_pn_src_expr(""); }

	if($SPC_pn_bkg_expr) {
		$gv->SPC_pn_bkg_expr($SPC_pn_bkg_expr);
	} else {
		$gv->SPC_pn_bkg_expr(""); }

	if($SPC_m1_src_expr) {
		$gv->SPC_m1_src_expr($SPC_m1_src_expr);
	} else {
		$gv->SPC_m1_src_expr(""); }

	if($SPC_m1_bkg_expr) {
		$gv->SPC_m1_bkg_expr($SPC_m1_bkg_expr);
	} else {
		$gv->SPC_m1_bkg_expr(""); }

	if($SPC_m2_src_expr) {
		$gv->SPC_m2_src_expr($SPC_m1_src_expr);
	} else {
		$gv->SPC_m2_src_expr(""); }

	if($SPC_m2_bkg_expr) {
		$gv->SPC_m2_bkg_expr($SPC_m2_bkg_expr);
	} else {
		$gv->SPC_m2_bkg_expr(""); }

#.. Parameters for Light Curve

	if($LC_pn_src_expr) {
		$gv->LC_pn_src_expr($LC_pn_src_expr);
	} else {
		$gv->LC_pn_src_expr(""); }

	if($LC_pn_bkg_expr) {
		$gv->LC_pn_bkg_expr($LC_pn_bkg_expr);
	} else {
		$gv->LC_pn_bkg_expr(""); }

	if($LC_m1_src_expr) {
		$gv->LC_m1_src_expr($LC_m1_src_expr);
	} else {
		$gv->LC_m1_src_expr(""); }

	if($LC_m1_bkg_expr) {
		$gv->LC_m1_bkg_expr($LC_m1_bkg_expr);
	} else {
		$gv->LC_m1_bkg_expr(""); }

	if($LC_m2_src_expr) {
		$gv->LC_m2_src_expr($LC_m1_src_expr);
	} else {
		$gv->LC_m2_src_expr(""); }

	if($LC_m2_bkg_expr) {
		$gv->LC_m2_bkg_expr($LC_m2_bkg_expr);
	} else {
		$gv->LC_m2_bkg_expr(""); }

	if($LC_pn_timebinsize) {		
		$gv->LC_pn_timebinsize($LC_pn_timebinsize);
	} else {
		$gv->LC_pn_timebinsize(100); } # in secs 
		
	if($LC_pn_e1_low) {		
		$gv->LC_pn_e1_low($LC_pn_e1_low);
	} else {
		$gv->LC_pn_e1_low(200.); }  # eV : For  producing light curves  		

	if($LC_pn_e1_up) {		
		$gv->LC_pn_e1_up($LC_pn_e1_up);
	} else {
		$gv->LC_pn_e1_up(10000.); }  # eV : For  producing light curves  		

	if($LC_m1_timebinsize) {
		$gv->LC_m1_timebinsize($LC_m1_timebinsize);
	} else {
		$gv->LC_m1_timebinsize(100); } # in secs 

	if($LC_m1_e1_low) {		
		$gv->LC_m1_e1_low($LC_m1_e1_low);
	} else {
		$gv->LC_m1_e1_low(200.); }  # eV : For  producing light curves  		

	if($LC_m1_e1_up) {		
		$gv->LC_m1_e1_up($LC_m1_e1_up);
	} else {
		$gv->LC_m1_e1_up(10000.); }  # eV : For  producing light curves  		

	if($LC_m2_timebinsize) {
		$gv->LC_m2_timebinsize($LC_m2_timebinsize);
	} else {
		$gv->LC_m2_timebinsize(100); } # in secs 

	if($LC_m2_e1_low) {		
		$gv->LC_m2_e1_low($LC_m2_e1_low);
	} else {
		$gv->LC_m2_e1_low(200.); }  # eV : For  producing light curves  		

	if($LC_m2_e1_up) {		
		$gv->LC_m2_e1_up($LC_m2_e1_up);
	} else {
		$gv->LC_m2_e1_up(10000.); }  # eV : For  producing light curves  		
		

    $gv->SPC_pn_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->SPC_pn_srcregion_X(0.);        # For circle region. 0: default
    $gv->SPC_pn_srcregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_pn_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_pn_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_pn_srcregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_pn_srcregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_pn_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->SPC_pn_bkgregion_X(0.);        # For circle region. 0: default
    $gv->SPC_pn_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_pn_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_pn_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: defaultt
    $gv->SPC_pn_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_pn_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_pn_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area
    $gv->SPC_m1_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->SPC_m1_srcregion_X(0.);        # For circle region. 0: default
    $gv->SPC_m1_srcregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_m1_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: defualt
    $gv->SPC_m1_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m1_srcregion_XLength(0.);  # For box region centered in X,Y. 0: automatic box region
    $gv->SPC_m1_srcregion_YLength(0.);  # For box region centered in X,Y. 0: automatic box region
    $gv->SPC_m1_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->SPC_m1_bkgregion_X(0.);        # For circle region. 0: default
    $gv->SPC_m1_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_m1_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m1_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m1_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m1_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m1_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area
    $gv->SPC_m2_srcregion("circle");    # Shape of source extraction region (circle,annulus,box). Default: circle
    $gv->SPC_m2_srcregion_X(0.);        # For circle region. 0: default
    $gv->SPC_m2_srcregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_m2_srcregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m2_srcregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m2_srcregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m2_srcregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m2_bkgregion("annulus");   # Shape of background extraction region (circle,annulus,box). Default: Annulus
    $gv->SPC_m2_bkgregion_X(0.);        # For circle region. 0: default
    $gv->SPC_m2_bkgregion_Y(0.);        # For circle region. 0: default
    $gv->SPC_m2_bkgregion_R1(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m2_bkgregion_R2(0.);       # For circle/annulus region centered in X,Y. 0: default
    $gv->SPC_m2_bkgregion_XLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m2_bkgregion_YLength(0.);  # For box region centered in X,Y. 0: default
    $gv->SPC_m2_areafactor(2.);         # For default circle regions: How much bigger the BKG area should be with respect to the on-source Area

#... RGS parameters
	$gv->RGS_withsrc($withsrc);
	$gv->RGS_srcstyle($srcstyle);
	$gv->RGS_srcra($srcra);
	$gv->RGS_srcdec($srcdec);
	$gv->RGS_srcdisp($srcdisp);
	$gv->RGS_srcxdsp($srcxdsp);
	$gv->RGS_srclabel($srclabel);
	$gv->RGS_srcrate($srcrate);
	$gv->RGS_keepcool($keepcool);
	$gv->RGS_rejflags($rejflags);
	$gv->RGS_spectrumbinnig($spectrumbinning); 

    return(0);
}
1;
